function servercommandgui_toggle(%x)
{
	if(%x)
	{
		if(!servercommandgui.isAwake())
			canvas.pushDialog(servercommandgui);
		else
			canvas.popDialog(servercommandgui);
	}
}

function servercommandgui_set()
{
	servercommandgui_list.clear();

	for(%a=0; %a<$servercommandgui::commandcount; %a++)
		servercommandgui_addpanel(%a);
}

function servercommandgui_addpanel(%a)
{
	if(%a $= "")
		%b = $servercommandgui::commandcount;
	else
		%b = %a;

	%y = %b * 74 + 4;

	%panel = new GuiSwatchCtrl()
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "4" SPC %y;
		extent = "326 70";
		minExtent = "8 2";
		visible = "1";
		color = "150 150 150 255";

		new GuiTextCtrl("servercommandgui_label_"@%b)
		{
			profile = "BlockChatChannelSize8Profile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "2 17";
			extent = "26 36";
			minExtent = "8 2";
			visible = "1";
			text = %b;
			maxLength = "255";
		};
		new GuiTextEditCtrl("servercommandgui_command_"@%b@"_1")
		{
			profile = "GuiTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "32 8";
			extent = "132 18";
			minExtent = "8 2";
			visible = "1";
			maxLength = "255";
			historySize = "0";
			password = "0";
			tabComplete = "0";
			sinkAllKeyEvents = "0";
		};
		new GuiTextEditCtrl("servercommandgui_command_"@%b@"_0")
		{
			profile = "GuiTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "172 8";
			extent = "132 18";
			minExtent = "8 2";
			visible = "1";
			maxLength = "255";
			historySize = "0";
			password = "0";
			tabComplete = "0";
			sinkAllKeyEvents = "0";
		};
		new GuiTextEditCtrl("servercommandgui_cycle_"@%b@"_1")
		{
			profile = "GuiTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "100 37";
			extent = "64 18";
			minExtent = "8 2";
			visible = "1";
			maxLength = "255";
			historySize = "0";
			password = "0";
			tabComplete = "0";
			sinkAllKeyEvents = "0";
		};
		new GuiTextEditCtrl("servercommandgui_cycle_"@%b@"_0")
		{
			profile = "GuiTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "240 37";
			extent = "64 18";
			minExtent = "8 2";
			visible = "1";
			maxLength = "255";
			historySize = "0";
			password = "0";
			tabComplete = "0";
			sinkAllKeyEvents = "0";
		};
		new GuiCheckBoxCtrl()
		{
			profile = "GuiCheckBoxProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "32 22";
			extent = "70 30";
			minExtent = "8 2";
			visible = "1";
			variable = "$servercommandgui::toserver_"@%b@"_1";
			text = "To Server";
			groupNum = "-1";
			buttonType = "ToggleButton";
		};
		new GuiCheckBoxCtrl()
		{
			profile = "GuiCheckBoxProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "32 40";
			extent = "70 30";
			minExtent = "8 2";
			visible = "1";
			variable = "$servercommandgui::loops_"@%b@"_1";
			text = "Loops";
			groupNum = "-1";
			buttonType = "ToggleButton";
		};
		new GuiCheckBoxCtrl()
		{
			profile = "GuiCheckBoxProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "172 22";
			extent = "70 30";
			minExtent = "8 2";
			visible = "1";
			variable = "$servercommandgui::toserver_"@%b@"_0";
			text = "To Server";
			groupNum = "-1";
			buttonType = "ToggleButton";
		};
		new GuiCheckBoxCtrl()
		{
			profile = "GuiCheckBoxProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "172 40";
			extent = "70 30";
			minExtent = "8 2";
			visible = "1";
			variable = "$servercommandgui::loops_"@%b@"_0";
			text = "Loops";
			groupNum = "-1";
			buttonType = "ToggleButton";
		};
	};
	servercommandgui_list.resize(1, 1, 330, %y + 74);
	servercommandgui_list.add(%panel);

	for(%c=0; %c<2; %c++)
	{
		eval("servercommandgui_command_"@%b@"_"@%c@".setvalue($servercommandgui::command_[%b,%c]);");
		eval("servercommandgui_cycle_"@%b@"_"@%c@".setvalue($servercommandgui::cycle_[%b,%c]);");

		if($servercommandgui::toserver_[%b,%c] $= "")
			$servercommandgui::toserver_[%b,%c] = 0;

		if($servercommandgui::loops_[%b,%c] $= "")
			$servercommandgui::loops_[%b,%c] = 0;
	}
}

function usekeybind(%key, %x)
{
	if(iseventpending($servercommandgui::schedule_[%key]))
		cancel($servercommandgui::schedule_[%key]);

	if($servercommandgui::command_[%key,%x] $= "")
		return;

	if($servercommandgui::loops_[%key,%x] && $servercommandgui::cycle_[%key,%x] > 0)
		$servercommandgui::schedule_[%key] = schedule($servercommandgui::cycle_[%key,%x], false, "usekeybind", %key, %x);

	if($servercommandgui::toserver_[%key,%x])
	{
		%find = "_";
		%replace = " ";
		%cmd = "\'"@ getword($servercommandgui::command_[%key,%x], 0) @"\'";
		for(%a=1; %a<getwordcount($servercommandgui::command_[%key,%x]); %a++)
			%cmd = %cmd @ ",\"" @ strreplace(getword($servercommandgui::command_[%key,%x], %a), %find, %replace) @ "\"";
		eval("commandtoserver("@%cmd@");");
	}
	else if(getsubstr($servercommandgui::command_[%key,%x],0,2) $= "f:")
	{
		%command = trim(getsubstr($servercommandgui::command_[%key,%x],2,strlen($servercommandgui::command_[%key,%x])));

		if(!strlen(%command))
			echo("Please specify a custom function after f:");
		else if(isFile("config/client/servercommandgui/functions/"@%command@".cs"))
			exec("config/client/servercommandgui/functions/"@%command@".cs");
		else
			echo("custom function" SPC %command SPC "not found.");
	}
	else
		eval($servercommandgui::command_[%key,%x]);
}

function servercommandgui_save(%x)
{
	for(%a=0; %a<$servercommandgui::commandcount; %a++)
	{
		for(%b=0; %b<2; %b++)
		{
			eval("$servercommandguitemp = servercommandgui_cycle_"@%a@"_"@%b@".getvalue();");
			if(!isInt($servercommandguitemp))
				eval("servercommandgui_cycle_"@%a@"_"@%b@".setvalue(0);");
			eval("$servercommandgui::command_"@%a@"_"@%b@" = servercommandgui_command_"@%a@"_"@%b@".getvalue();");
			eval("$servercommandgui::cycle_"@%a@"_"@%b@" = servercommandgui_cycle_"@%a@"_"@%b@".getvalue();");
		}
	}
	$servercommandgui::savepref = 0;

	if(%x)
		export("$servercommandgui::*", "config/client/servercommandgui/pref"@%x@".cs");

	export("$servercommandgui::*", "config/client/servercommandgui/current.cs");
	canvas.popDialog(servercommandgui);
}

function servercommandgui_load(%x)
{
	for(%a=0; %a<2; %a++)
	{
		$servercommandgui::toserver_[%x,%a] = 0;
		$servercommandgui::loops_[%x,%a] = 0;
	}

	if(isfile("config/client/servercommandgui/pref"@%x@".cs"))
		exec("config/client/servercommandgui/pref"@%x@".cs");
	else
		exec("config/client/servercommandgui/current.cs");

	servercommandgui_set();
}

function servercommandgui_pref(%x)
{
	if($servercommandgui::savepref)
		servercommandgui_save(%x);
	else
		servercommandgui_load(%x);
}
	
function servercommandgui_cancel()
{
	if(isfile("config/client/servercommandgui/current.cs"))
		exec("config/client/servercommandgui/current.cs");

	servercommandgui_set();

	canvas.popDialog(servercommandgui);
}

function servercommandgui_help()
{
	messageboxok("ServerCommandGUI Help", "This mod allows you to bind commands to keys.\n\nClick New to create a new keybind.\nType the command into the larger text box, the loop delay in the smaller text box, and don't forget to click save.\nYou can define custom functions with the function editor.  Click the expand arrow to begin!\n\nFor more help, please reference the instructions.txt in the add-ons/client_servercommandgui.zip folder.");
}

function servercommandgui_newcommand()
{
	servercommandgui_addpanel();

	%file = new fileObject();
	%file.openforwrite("config/client/servercommandgui/functions.cs");
	for(%b=0; %b<=$servercommandgui::commandcount; %b++)
		%file.writeline("function triggerkeybind"@%b@"(%x){usekeybind("@%b@",%x);}");
	%file.close();
	%file.delete();
	exec("config/client/servercommandgui/functions.cs");

	$servercommandgui::commandcount++;
	if($servercommandgui::commandcount > $servercommandguimaxfunctions)
	{
		$servercommandguimaxfunctions = $servercommandgui::commandcount;

		%file = new fileObject();
		%file.openforwrite("config/client/servercommandgui/dontdeletethiswhateveryoudo.cs");
		%file.writeline("/" @ "/ Deleting this file has a chance of screwing up some of your keybinds, just don't do it.");
		%file.writeline("$servercommandguimaxfunctions=" @ $servercommandguimaxfunctions @ ";");
		%file.close();
		%file.delete();

		for(%a=$remapcount; %a>$servercommandguiremap; %a--)
		{
			if($remapdivision[%a - 1] $= "Custom Keybinds")
				$remapdivision[%a] = "";
			else
				$remapdivision[%a] = $remapdivision[%a - 1];
			$remapname[%a] = $remapname[%a - 1];
			$remapcmd[%a] = $remapcmd[%a - 1];
		}
		$remapname[$servercommandguiremap] = "Keybind" SPC $servercommandgui::commandcount - 1;
		$remapcmd[$servercommandguiremap] = "triggerkeybind"@$servercommandgui::commandcount - 1;
		$remapcount++;
	}
}

//function editor

function servercommandgui_togglefunctioneditor()
{
	if(!$servercommandgui_fe)
	{
		$servercommandgui_fe = true;

		%editor = new GuiSwatchCtrl(servercommandgui_functioneditor) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "336 25";
			extent = "300 370";
			minExtent = "8 2";
			visible = "1";
			color = "0 18 118 2";

			new GuiScrollCtrl() {
				profile = "GuiScrollProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 96";
				extent = "300 275";
				minExtent = "8 2";
				visible = "1";
				willFirstRespond = "0";
				hScrollBar = "dynamic";
				vScrollBar = "dynamic";
				constantThumbHeight = "0";
				childMargin = "0 0";
				rowHeight = "40";
				columnWidth = "30";

				new GuiMLTextEditCtrl(servercommandgui_functionpad) {
					profile = "GuiMLTextEditProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "1 1";
					extent = "282 275";
					minExtent = "8 2";
					visible = "1";
					lineSpacing = "2";
					allowColorChars = "0";
					maxChars = "-1";
					maxBitmapHeight = "-1";
					selectable = "1";
				};
			};
			new GuiScrollCtrl() {
				profile = "GuiScrollProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "176 0";
				extent = "124 96";
				minExtent = "8 2";
				visible = "1";
				willFirstRespond = "0";
				hScrollBar = "alwaysOff";
				vScrollBar = "dynamic";
				constantThumbHeight = "0";
				childMargin = "0 0";
				rowHeight = "40";
				columnWidth = "30";

				new GuiTextListCtrl(servercommandgui_functionlist) {
					profile = "GuiTextListProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "1 1";
					extent = "122 2";
					minExtent = "8 2";
					visible = "1";
					enumerate = "0";
					resizeCell = "1";
					columns = "0";
					fitParentWidth = "1";
					clipColumnText = "0";
				};
			};
			new GuiTextEditCtrl(servercommandgui_functionname) {
				profile = "GuiTextEditProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 72";
				extent = "176 18";
				minExtent = "8 2";
				visible = "1";
				maxLength = "255";
				historySize = "0";
				password = "0";
				tabComplete = "0";
				sinkAllKeyEvents = "0";
			};
			new GuiBitmapButtonCtrl() {
				profile = "BlockButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "8 36";
				extent = "48 20";
				minExtent = "8 2";
				visible = "1";
				command = "servercommandgui_checksavefunction();";
				text = "Save";
				groupNum = "-1";
				buttonType = "PushButton";
				bitmap = "base/client/ui/button1";
				lockAspectRatio = "0";
				alignLeft = "0";
				overflowImage = "0";
				mKeepCached = "0";
				mColor = "255 255 255 255";
			};
			new GuiTextCtrl() {
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "46 56";
				extent = "84 18";
				minExtent = "8 2";
				visible = "1";
				text = "Name of function";
				maxLength = "255";
			};
			new GuiBitmapButtonCtrl() {
				profile = "BlockButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "124 8";
				extent = "48 20";
				minExtent = "8 2";
				visible = "1";
				command = "servercommandgui_promptloadfunction();";
				text = "Load";
				groupNum = "-1";
				buttonType = "PushButton";
				bitmap = "base/client/ui/button1";
				lockAspectRatio = "0";
				alignLeft = "0";
				overflowImage = "0";
				mKeepCached = "0";
				mColor = "255 255 255 255";
			};
			new GuiBitmapButtonCtrl() {
				profile = "BlockButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "8 8";
				extent = "48 20";
				minExtent = "8 2";
				visible = "1";
				command = "servercommandgui_functionhelp();";
				text = "Help";
				groupNum = "-1";
				buttonType = "PushButton";
				bitmap = "base/client/ui/button1";
				lockAspectRatio = "0";
				alignLeft = "0";
				overflowImage = "0";
				mKeepCached = "0";
				mColor = "255 255 255 255";
			};
			new GuiBitmapButtonCtrl() {
				profile = "BlockButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "66 8";
				extent = "48 20";
				minExtent = "8 2";
				visible = "1";
				command = "servercommandgui_promptnewfunction();";
				text = "New";
				groupNum = "-1";
				buttonType = "PushButton";
				bitmap = "base/client/ui/button1";
				lockAspectRatio = "0";
				alignLeft = "0";
				overflowImage = "0";
				mKeepCached = "0";
				mColor = "255 255 255 255";
			};
			new GuiCheckBoxCtrl(servercommandgui_FEAE) {
				profile = "GuiCheckBoxProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "70 36";
				extent = "70 20";
				minExtent = "8 2";
				visible = "1";
				variable = "$servercommandgui_FEAE";
				text = "AutoExec";
				groupNum = "-1";
				buttonType = "ToggleButton";
			};
		};
		servercommandgui_FEAE.setvalue(0);
		servercommandgui_window.resize(getword(servercommandgui_window.getPosition(), 0), getword(servercommandgui_window.getPosition(), 1), 640, 400);
		servercommandgui_window.add(%editor);
		servercommandgui_setfunctioneditor();
		servercommandgui_loadfunctionlist();
		servercommandgui_expandbutton.settext("<<");
	}
	else if(servercommandgui_functionpad.getvalue() $= "")
		servercommandgui_retract();
	else
		messageboxyesno("Command GUI Function Editor", "Save before closing editor?", "servercommandgui_checksavefunction(3);", "servercommandgui_retract();");
}

function servercommandgui_retract()
{
	if(!$servercommandgui_fe)
		return;
	servercommandgui_expandbutton.settext(">>");
	$servercommandgui_fe = false;
	$servercommandgui_backup = servercommandgui_functionpad.getvalue();
	$servercommandgui_backupname = servercommandgui_functionname.getvalue();

	servercommandgui_functioneditor.delete();

	servercommandgui_window.resize(getword(servercommandgui_window.getPosition(), 0), getword(servercommandgui_window.getposition(), 1), 340, 400);
}

function servercommandgui_promptloadfunction()
{
	if((%row = servercommandgui_functionlist.getselectedid()) >= 0)
	{
		%x = strreplace(getfield(servercommandgui_functionlist.getrowtextbyid(%row), 0), " ", "_");

		if(servercommandgui_functionpad.getvalue() $= "")
			servercommandgui_setfunctioneditor(%x);
		else
			messageboxyesno("Command GUI Function Editor", "Save before loading a new function?", "servercommandgui_checksavefunction(2,"@%x@");", "servercommandgui_setfunctioneditor("@%x@");");
	}
	else
		messageboxok("Command GUI Function Editor", "Select an item from the list to load");
}

function servercommandgui_setfunctioneditor(%x)
{
	if(%x !$= "" && %x !$= "0")
	{
		%x = strreplace(%x, "_", " ");
		servercommandgui_functionpad.setvalue("");
		servercommandgui_functionname.setvalue(%x);

		if(isfile("config/client/servercommandgui/functions/"@%x@".cs"))
		{
			%file = new fileobject();
			%file.openforread("config/client/servercommandgui/functions/"@%x@".cs");

			while(!%file.iseof())
				servercommandgui_functionpad.setvalue(servercommandgui_functionpad.getvalue() @ %file.readline() NL "");

			%file.close();
			%file.openforread("config/client/servercommandgui/autoexec.cs");

			while(!%file.iseof())
			{
				if(!strcmp(%file.readline(), "exec(\"config/client/servercommandgui/functions/"@%x@".cs\");"))
				{
					servercommandgui_FEAE.setvalue(1);
					%found = true;
					break;
				}
			}

			if(!%found)
				servercommandgui_FEAE.setvalue(0);

			%file.close();
			%file.delete();
		}
		else
			servercommandgui_functionpad.setvalue("Error - File" SPC %x @".cs not found!");
	}
	else
	{
		servercommandgui_functionpad.setvalue($servercommandgui_backup);
		servercommandgui_functionname.setvalue($servercommandgui_backupname);
	}
}

function servercommandgui_loadfunctionlist()
{
	servercommandgui_functionlist.clear();

	for(%a = findFirstFile("config/client/servercommandgui/functions/*.cs"); %a!$=""; %a = findNextFile("config/client/servercommandgui/functions/*.cs"))
		servercommandgui_functionlist.addrow(servercommandgui_functionlist.rowcount(), getsubstr(%a,41,strlen(%a)-44));
}

function servercommandgui_checksavefunction(%x, %load)
{
	%y = servercommandgui_functionname.getvalue();

	if(isfile("config/client/servercommandgui/functions/"@%y@".cs"))
	{
		if(%x $= "")
			%x = "0";

		if(%load $= "")
			%load = "0";

		messageboxyesno("Command GUI Function Editor", "Are you sure you want to\nOverwrite function" SPC %y @"?", "servercommandgui_savefunction("@%x@","@strreplace(%y, " ", "_")@","@%load@");", "");
	}
	else
		servercommandgui_savefunction(%x, %y, %load);
}

function servercommandgui_savefunction(%x, %y, %load)
{
	%y = strreplace(%y, "_", " ");
	if(!strlen(%y) || %y $= "0")
		return messageboxok("Command GUI Function Editor", "Please enter a file name.");

	%file = new fileObject();
	%file.openforwrite("config/client/servercommandgui/functions/"@%y@".cs");
	%file.writeline(servercommandgui_functionpad.getvalue());
	%file.close();
	%file.delete();

	servercommandgui_loadfunctionlist();

	if(isfile("config/client/servercommandgui/autoexec.cs"))
	{
		%i=0;

		%file = new fileobject();
		%file.openforread("config/client/servercommandgui/autoexec.cs");

		while(!%file.iseof())
		{
			if(strcmp((%line = %file.readline()), "exec(\"config/client/servercommandgui/functions/"@%y@".cs\");") != 0)
			{
				$servercommandguitemploop[%i] = %line;
				%i++;
			}
			else if($servercommandgui_FEAE && !%exists)
			{
				%exists = true;
				$servercommandguitemploop[%i] = %line;
				%i++;
			}
		}

		%file.close();
		%file.openforwrite("config/client/servercommandgui/autoexec.cs");

		for(%a=0; %a<%i; %a++)
			%file.writeline($servercommandguitemploop[%a]);

		%file.close();
		%file.delete();
	}

	if($servercommandgui_FEAE)
	{
		exec("config/client/servercommandgui/functions/"@%y@".cs");

		if(!%exists)
		{
			%file = new fileobject();
			%file.openforappend("config/client/servercommandgui/autoexec.cs");
			%file.writeline("exec(\"config/client/servercommandgui/functions/"@%y@".cs\");");
			%file.close();
			%file.delete();
		}
	}

	if(%x == 1)
		servercommandgui_newfunction();
	else if(%x == 2)
		servercommandgui_setfunctioneditor(%load);
	else if(%x == 3)
		servercommandgui_retract();
}

function servercommandgui_promptnewfunction()
{
	if(servercommandgui_functionpad.getvalue() $= "")
		servercommandgui_newfunction();
	else
		messageboxyesno("Command GUI Function Editor", "Save before creating a new function?", "servercommandgui_checksavefunction(1);", "servercommandgui_newfunction();");
}

function servercommandgui_newfunction()
{
	servercommandgui_functionpad.setvalue("");
	servercommandgui_functionname.setvalue("");
	servercommandgui_FEAE.setvalue(0);
}

function servercommandgui_functionhelp()
{
	messageboxok("Command GUI Function Editor", "To use the function editor, you type out a script into the function pad below, give it a name, and then save it.Using the format\nf:functionname\nYou can use a keybind to execute your script.\nIf your script has functions in it, you can execute it by checking the AutoExec box.\n\n For more help, please reference the instructions.txt");
}

//all those rebels that dont like being in functions

$remapdivision[$remapcount] = "Custom Keybinds";
$servercommandgui::commandcount = 0;
$servercommandguimaxfunctions = 0;
$servercommandguiremap = $remapcount;

if(isfile("config/client/servercommandgui/current.cs"))
	exec("config/client/servercommandgui/current.cs");

if(isfile("config/client/servercommandgui/functions.cs"))
	exec("config/client/servercommandgui/functions.cs");

if(isfile("config/client/servercommandgui/dontdeletethiswhateveryoudo.cs"))
	exec("config/client/servercommandgui/dontdeletethiswhateveryoudo.cs");

if(isfile("config/client/servercommandgui/autoexec.cs"))
	exec("config/client/servercommandgui/autoexec.cs");

for(%a=0; %a<$servercommandguimaxfunctions; %a++)
{
	$remapname[$remapcount] = "Keybind" SPC $servercommandguimaxfunctions - (%a + 1);
	$remapcmd[$remapcount] = "triggerkeybind" @ $servercommandguimaxfunctions - (%a + 1);
	$remapcount++;
}

$remapname[$remapcount] = "Toggle Keybind Gui";
$remapcmd[$remapcount] = "servercommandgui_toggle";
$remapcount++;

servercommandgui_set();